;
;HASH TABLE CREATION
;
;
;
;SYMBOL DEFINITION
;
	DEL3	EQU	0
	DEL4	EQU	';'
	CR	EQU	0DH
	SPACE	EQU	20H
	TAB	EQU	9
	LF	EQU	0AH
	EOF	EQU	1AH
	CBASE	EQU	6
;
;TERMINATER
;
;
;FDOS USE
;
;SYSTEM CALL COMMANDS
;
REBOOT	EQU	0	;CP/M RE-BOOT
BDOS	EQU	5
SETDMA	EQU	26
OPEN	EQU	15
READS	EQU	20	;SEQUENTIAL READ
WRITES	EQU	21	;SEQUENTIAL WRITE
CLOSE	EQU	16
MAKE	EQU	22
DELETE	EQU	19
LIST	EQU	5
CONOUT	EQU	2
;
;
;
	ORG 100H
;
STRT:	LHLD	CBASE
	LXI	B,-20
	DAD	B
	SPHL	;STACK POINTER INITIALIZE
	LXI	H,BEGMES
	CALL	MESSAGE
	CALL	DLOAD
	LXI	D,TXTST1
	LHLD	BUFSTRT ;LOAD NEXT BUFFER TOP
	XRA	A
	STA	WCOUNT
VST1:	CALL	SEARCH
	LDA	FSTATUS
	ORA	A
	JNZ	VST2
	LDA	WCOUNT
	INR	A
	STA	WCOUNT
	JMP	VST1
;
VST2:	CALL	SEARCH1
;
;AFTER SEARCH1, THE EXTRACTED 'DB	'MNEMONIC',ECT. '
;IS STORED IN THE NEXT BUFFER.
;
	LDAX	D
	CPI	EOF
	JNZ	VST2
	MVI	B,128
	MVI	A,EOF
VST10:	MOV	M,A
	INX	H
	DCR	B
	JNZ	VST10
	JMP	POST1
;
;<TAB>,DB SEARCH
; (DE)~ SEARCH >> (HL)
;
SEARCH:	XRA	A
	STA	FSTATUS ;FIND STATUS
SEARCH1: LDAX	D
	INX	D
	CPI	TAB
	JZ	SRCH2
	MOV	M,A
	INX	H
	CPI	LF
	RZ
	CPI	EOF
	RZ
	JMP	SEARCH1
;
;SERACH 'DB'
;
SRCH2:	MOV	M,A
	INX	H
	LDAX	D
	CPI	'D'
	JNZ	SEARCH1
	INX	D
	MOV	M,A
	INX	H
	LDAX	D
	CPI	'B'
	JNZ	SEARCH1
	INX	D
	MOV	M,A
	INX	H
	PUSH	D
	STA	FSTATUS
;
SRCH3:	LDAX	D
	CPI	''''
	JZ	SRCH4
	MOV	M,A
	INX	H
	INX	D
	JMP	SRCH3
;
SRCH4:	MVI	B,0
	INX	D
SRCH5:	LDAX	D
	CPI	''''
	JZ	SRCH6
	ADD	B	;CALCULATE SUM OF THE ASCII
	MOV	B,A
	INX	D
	JMP	SRCH5
;
SRCH6:	POP	D
	MOV	A,B
	ORI	0C0H	;SET MSB & BIT 6
;THIS IS HASH DATA MARK FOR SEPARATE THE DATA FROM ASCII.
	MOV	M,A
	INX	H
;
;
;MOVE REMAINING CHARACTERS UP TO CR/LF.
;
SRCH7:	LDAX	D
	INX	D
	MOV	M,A
	INX	H
	CPI	LF
	JNZ	SRCH7
	RET
;
;
;POST PROCEDURE
;
POST1:	LXI	D,TXTST1
	LHLD	BUFSTRT
	XCHG
;
;NOW, STORE THE EXTRACTED DATA TO THE FORMER BUFFER.
;(THE FORMER IS DESTROIED.)
;
POST2:	LDA	WCOUNT
	MOV	B,A
	ORA	A
	JZ	POST3
BBB:	CALL	TRA1N
	DCR	B
	JNZ	BBB
;
POST3:	MVI	C,0
POST4:	CALL	PUTNMN
	XCHG
	LHLD	BUFSTRT
	XCHG
POST5:	CALL	SRC1H
	CZ	TRA2N
	LDAX	D
	CPI	EOF
	JNZ	POST5
	PUSH	D
	PUSH	B
	LXI	D,EDATA
POST6:	LDAX	D
	ORA	A
	JZ	POST7
	MOV	M,A
	INX	H
	INX	D
	JMP	POST6
;
POST7:	POP	B
	POP	D
	INR	C
	MOV	A,C
	CPI	32	;HASH TOTAL COUNTS
	JNC	POST10
	JMP	POST4
;
;BLOCK END WORD
;
EDATA:	DB ';',CR,LF,TAB,'DB',TAB,'0FFH',CR,LF,';',CR,LF
	DB	0
;
;
POST10:	MVI	A,EOF
	MOV	M,A
	INX	H
	SHLD	BUFEND
	MVI	B,128
POST11:	MOV	M,A
	INX	H
	DCR	B
	JNZ	POST11
;
	CALL	DSAVE
	JMP	0
;
;
;
PUTNMN:	PUSH	D
	LXI	D,NMNDATA
PUTN2:	LDAX	D
	ORA	A
	JZ	PUTN1
	MOV	M,A
	INX	H
	INX	D
	JMP	PUTN2
;
PUTN1:	MOV	A,C
	PUSH	B
	PUSH	A
	RAR
	RAR
	RAR
	RAR
	CALL	HAT
	MOV	M,A
	INX	H
	POP	A
	CALL	HAT
	MOV	M,A
	INX	H
	MVI	M,':'
	INX	H
	POP	B
	POP	D
	RET
;
;HEX TO ASCII
;
HAT:	ANI	0FH
	CPI	0AH
	JC	HAT2
	ADI	7
HAT2:	ADI	30H
	RET
;
;
TRA1N:	LDAX	D
	MOV	M,A
	INX	H
	INX	D
	CPI	LF
	RZ
	JMP	TRA1N
;
TRA2N:	LDAX	D
	CPI	TAB
	INX	D
	JNZ	TRA2N
TRA2N1:	MOV	M,A
	INX	H
	LDAX	D
	MOV	M,A
	INX	H
	INX	D
	LDAX	D
	MOV	M,A
	INX	H
	INX	D
	LDAX	D
	MOV	M,A
	INX	H
	INX	D
	INX	D
TRA2N3:	LDAX	D
	INX	D
	MOV	M,A
	INX	H
	CPI	LF
	JNZ	TRA2N3
	RET
;
SRC1H:	PUSH	D
SRC1H1:	LDAX	D
	CPI	EOF
	JZ	SRC1H5
	INX	D
	CPI	LF
	JZ	SRC1H2
	CPI	TAB
	JNZ	SRC1H1
	LDAX	D
	CPI	'D'
	JNZ	SRC1H1
	INX	D
	LDAX	D
	CPI	'B'
	JNZ	SRC1H1
	INX	D
	INX	D
	LDAX	D
	ANI	1FH
	CMP	C
	JNZ	SRC1H1
	POP	D
	XRA	A
	RET
;
SRC1H2:	POP	A
	JMP	SRC1H
;
SRC1H5:	POP	A
	XRA	A
	INR	A
	RET
;
;
;DISK LOAD
;
DLOAD:	CALL	FCBRES	;FCB RESET
	LXI	D,FCB
	MVI	C,OPEN
	CALL	BDOS	;OPEN DATA2.LIB
	INR	A	;ERROR ?
	JZ	ERROR
	LXI	D,TXTST1
LOAD:	PUSH	D	;SAVE DMA ADDRESS
	MVI	C,SETDMA
	CALL	BDOS	;SET DMA ADDRESS
	MVI	C,READS
	LXI	D,FCB
	CALL	BDOS	;READ SECTOR
	ORA	A	;FILE END ?
	JZ	RDMORE	;NO, READ MORE
;
;ALL HAS READ
;
	MVI	C,CLOSE
	LXI	D,FCB 
	CALL	BDOS	;CLOSE FILE
	POP	D	;THROW AWAY DMA ADD.
	XCHG
	LXI	D,200
	DAD	D	;MARGIN FOR BLOCK END WORD
	SHLD	BUFSTRT ;SAVE NEXT BUFFER START ADDRESS
	RET
RDMORE:	POP	D	;GET DMA ADDRESS
	LXI	H,128
	DAD	D	;ADD 128 TO DMA ADD.
	XCHG	;PUT IT BACK IN D
	JMP	LOAD	;AND READ SOME MORE
;
;DISK SAVE
;
DSAVE:	CALL	FCBRES	;FCB RESET
	LXI	D,FCB
	MVI	C,DELETE
	CALL	BDOS	;ERASE FILE IF IT EXISTS
	LXI	D,FCB	
	MVI	C,MAKE
	CALL	BDOS	;MAKE A NEW ONE
	INR	A
	JZ	ERROR	;DISK OVF.
	LXI	D,TXTST1
SAVE:	PUSH	D	;SAVE DMA ADDRESS
	MVI	C,SETDMA	;
	CALL	BDOS	;SET DMA ADDRESS
	MVI	C,WRITES
	LXI	D,FCB 
	CALL	BDOS	;WRITE SECTOR
	ORA	A	;SET FLAGS
	JNZ	ERROR	;IF NOT ZERO, ERROR
	POP	D	;GET DMA ADD. BACK
	LXI	H,128
	DAD	D
	XCHG
	PUSH	D
	LHLD	BUFEND
	MOV	A,D
	CMA
	MOV	D,A
	MOV	A,E
	CMA
	MOV	E,A
	INX	D	;DE=-DE
	DAD	D	;HL-DE
	POP	D
	JNC	SAVDON	;SAVE DONE
	JMP	SAVE	;WRITE SOME MORE
SAVDON:	MVI	C,CLOSE
	LXI	D,FCB 
	CALL	BDOS	;CLOSE FILE
	RET
;
;FILE CONTROL BLOCK RESET
;
FCBRES:	LXI	H,FCB1
	MVI	B,21
	XRA	A
FCBR1:	MOV	M,A
	INX	H
	DCR	B
	JNZ	FCBR1
	RET
;
;PRINT MESSAGE TO CONSOLE
;
;FROM (HL)~ UNTIL HIT 0H
;BC,DE CONSERVED
;
MESSAGE:	PUSH	D
	PUSH	B
MSG1:	MOV	A,M
	ORA	A
	JZ	MSG2
	INX	H
	PUSH	H
	MOV	E,A
	MVI	C,CONOUT
	CALL	BDOS
	POP	H
	JMP	MSG1
;
MSG2:	POP	B
	POP	D
	RET
;
;ERROR PRINT
;
ERROR:	LXI	H,ERMES
	CALL	MESSAGE
	JMP	REBOOT
;
;ERROR MESSAGE
;
ERMES:	DB	'DISK R/W ERROR.',CR,LF,0
;
;BEGIN MESSAGE
;
BEGMES:	DB	CR,LF,'DATA2.LIB TRANSLATION.',CR,LF,0
;
;
FCB:	DB	0	;DEFAULT DRIVE
	DB	'DATA2   '
	DB	'LIB'
;
FCB1:	DS	22
;
BUFSTRT:	DS	2
BUFEND:	DS	2
FSTATUS: DS	1	;'DB' FIND STATUS
WCOUNT:	DS	1	;FILE TOP SKIP LINES COUNTS
;
;
NMNDATA:	DB 'NMN',0
;
TXTST1:	;TEXT BUFFER
;
;
END
